local AceGUI = LibStub("AceGUI-3.0")

function MorthalinRaidTools:ConstructTextConfirm(title, text, status, typeOfConfirm)
	if(self.ui.confirmTextFrame ~= nil and self.ui.confirmTextFrame:IsVisible()) then
		self.ui.confirmTextFrame:Hide();
	end
	self.ui.confirmTextFrame = AceGUI:Create("Frame");
	self.ui.confirmTextFrame:SetTitle(title);
	self.ui.confirmTextFrame:SetStatusText(status);
	self.ui.confirmTextFrame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end);
	self.ui.confirmTextFrame:SetLayout("Flow");
	self.ui.confirmTextFrame:SetWidth(350);
	self.ui.confirmTextFrame:SetHeight(155);
	self.ui.confirmTextFrame:EnableResize(false);
	
	local label = AceGUI:Create("Label");
	label:SetText(text);
	label:SetFullWidth(true);
	self.ui.confirmTextFrame:AddChild(label);
	
	local addCharName = AceGUI:Create("EditBox");
	addCharName:SetLabel("New character");
	addCharName:SetWidth(220);
	addCharName:DisableButton(true);
	addCharName:SetCallback("OnTextChanged", function(widget, event, text)
		if(string.len(text) ~= 0) then
			if(typeOfConfirm == 1) then
				self:ConstructWhisperer(addCharName, text, 4);
			elseif(typeOfConfirm == 2) then
				self:ConstructWhisperer(addCharName, text, 5);
			end
		else
			self:HideWhisperer();
		end
	end)
	addCharName:SetCallback("OnEnterPressed", function(widget, event, text) MorthalinRaidTools:ReplacePlayer(text); end)
	self.ui.confirmTextFrame:AddChild(addCharName);
	
	local btnYes = AceGUI:Create("Button");
	btnYes:SetText("Confirm");
	btnYes:SetWidth(150);
	btnYes:SetCallback("OnClick", function() 
		if(typeOfConfirm == 1) then
			MorthalinRaidTools:ReplacePlayer(addCharName:GetText());
		elseif(typeOfConfirm == 2) then
			MorthalinRaidTools:AddPlayerSchedule(addCharName:GetText());
		end
		self.ui.confirmTextFrame:Hide();
	end)
	self.ui.confirmTextFrame:AddChild(btnYes);
	
	local btnNo = AceGUI:Create("Button");
	btnNo:SetText("Back");
	btnNo:SetWidth(150);
	btnNo:SetCallback("OnClick", function() self.ui.confirmTextFrame:Hide(); end)
	self.ui.confirmTextFrame:AddChild(btnNo);
end
